// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from r2r_spl_test_interfaces:msg/ArrayTypes.idl
// generated code does not contain a copyright notice

#ifndef R2R_SPL_TEST_INTERFACES__MSG__DETAIL__ARRAY_TYPES__TRAITS_HPP_
#define R2R_SPL_TEST_INTERFACES__MSG__DETAIL__ARRAY_TYPES__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "r2r_spl_test_interfaces/msg/detail/array_types__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace r2r_spl_test_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const ArrayTypes & msg,
  std::ostream & out)
{
  out << "{";
  // member: data_int8_static
  {
    if (msg.data_int8_static.size() == 0) {
      out << "data_int8_static: []";
    } else {
      out << "data_int8_static: [";
      size_t pending_items = msg.data_int8_static.size();
      for (auto item : msg.data_int8_static) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: data_bool_static
  {
    if (msg.data_bool_static.size() == 0) {
      out << "data_bool_static: []";
    } else {
      out << "data_bool_static: [";
      size_t pending_items = msg.data_bool_static.size();
      for (auto item : msg.data_bool_static) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: data_int8_unbounded_dynamic
  {
    if (msg.data_int8_unbounded_dynamic.size() == 0) {
      out << "data_int8_unbounded_dynamic: []";
    } else {
      out << "data_int8_unbounded_dynamic: [";
      size_t pending_items = msg.data_int8_unbounded_dynamic.size();
      for (auto item : msg.data_int8_unbounded_dynamic) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: data_bool_unbounded_dynamic
  {
    if (msg.data_bool_unbounded_dynamic.size() == 0) {
      out << "data_bool_unbounded_dynamic: []";
    } else {
      out << "data_bool_unbounded_dynamic: [";
      size_t pending_items = msg.data_bool_unbounded_dynamic.size();
      for (auto item : msg.data_bool_unbounded_dynamic) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: data_int8_bounded_dynamic
  {
    if (msg.data_int8_bounded_dynamic.size() == 0) {
      out << "data_int8_bounded_dynamic: []";
    } else {
      out << "data_int8_bounded_dynamic: [";
      size_t pending_items = msg.data_int8_bounded_dynamic.size();
      for (auto item : msg.data_int8_bounded_dynamic) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: data_bool_bounded_dynamic
  {
    if (msg.data_bool_bounded_dynamic.size() == 0) {
      out << "data_bool_bounded_dynamic: []";
    } else {
      out << "data_bool_bounded_dynamic: [";
      size_t pending_items = msg.data_bool_bounded_dynamic.size();
      for (auto item : msg.data_bool_bounded_dynamic) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: data_string
  {
    out << "data_string: ";
    rosidl_generator_traits::value_to_yaml(msg.data_string, out);
    out << ", ";
  }

  // member: data_string_bounded
  {
    out << "data_string_bounded: ";
    rosidl_generator_traits::value_to_yaml(msg.data_string_bounded, out);
    out << ", ";
  }

  // member: data_wstring
  {
    out << "data_wstring: ";
    rosidl_generator_traits::value_to_yaml(msg.data_wstring, out);
    out << ", ";
  }

  // member: data_wstring_bounded
  {
    out << "data_wstring_bounded: ";
    rosidl_generator_traits::value_to_yaml(msg.data_wstring_bounded, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ArrayTypes & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: data_int8_static
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data_int8_static.size() == 0) {
      out << "data_int8_static: []\n";
    } else {
      out << "data_int8_static:\n";
      for (auto item : msg.data_int8_static) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: data_bool_static
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data_bool_static.size() == 0) {
      out << "data_bool_static: []\n";
    } else {
      out << "data_bool_static:\n";
      for (auto item : msg.data_bool_static) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: data_int8_unbounded_dynamic
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data_int8_unbounded_dynamic.size() == 0) {
      out << "data_int8_unbounded_dynamic: []\n";
    } else {
      out << "data_int8_unbounded_dynamic:\n";
      for (auto item : msg.data_int8_unbounded_dynamic) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: data_bool_unbounded_dynamic
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data_bool_unbounded_dynamic.size() == 0) {
      out << "data_bool_unbounded_dynamic: []\n";
    } else {
      out << "data_bool_unbounded_dynamic:\n";
      for (auto item : msg.data_bool_unbounded_dynamic) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: data_int8_bounded_dynamic
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data_int8_bounded_dynamic.size() == 0) {
      out << "data_int8_bounded_dynamic: []\n";
    } else {
      out << "data_int8_bounded_dynamic:\n";
      for (auto item : msg.data_int8_bounded_dynamic) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: data_bool_bounded_dynamic
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data_bool_bounded_dynamic.size() == 0) {
      out << "data_bool_bounded_dynamic: []\n";
    } else {
      out << "data_bool_bounded_dynamic:\n";
      for (auto item : msg.data_bool_bounded_dynamic) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: data_string
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "data_string: ";
    rosidl_generator_traits::value_to_yaml(msg.data_string, out);
    out << "\n";
  }

  // member: data_string_bounded
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "data_string_bounded: ";
    rosidl_generator_traits::value_to_yaml(msg.data_string_bounded, out);
    out << "\n";
  }

  // member: data_wstring
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "data_wstring: ";
    rosidl_generator_traits::value_to_yaml(msg.data_wstring, out);
    out << "\n";
  }

  // member: data_wstring_bounded
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "data_wstring_bounded: ";
    rosidl_generator_traits::value_to_yaml(msg.data_wstring_bounded, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ArrayTypes & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace r2r_spl_test_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use r2r_spl_test_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const r2r_spl_test_interfaces::msg::ArrayTypes & msg,
  std::ostream & out, size_t indentation = 0)
{
  r2r_spl_test_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use r2r_spl_test_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const r2r_spl_test_interfaces::msg::ArrayTypes & msg)
{
  return r2r_spl_test_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<r2r_spl_test_interfaces::msg::ArrayTypes>()
{
  return "r2r_spl_test_interfaces::msg::ArrayTypes";
}

template<>
inline const char * name<r2r_spl_test_interfaces::msg::ArrayTypes>()
{
  return "r2r_spl_test_interfaces/msg/ArrayTypes";
}

template<>
struct has_fixed_size<r2r_spl_test_interfaces::msg::ArrayTypes>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<r2r_spl_test_interfaces::msg::ArrayTypes>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<r2r_spl_test_interfaces::msg::ArrayTypes>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // R2R_SPL_TEST_INTERFACES__MSG__DETAIL__ARRAY_TYPES__TRAITS_HPP_
