// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from r2r_spl_test_interfaces:msg/ArrayTypes.idl
// generated code does not contain a copyright notice
#include "r2r_spl_test_interfaces/msg/detail/array_types__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `data_int8_unbounded_dynamic`
// Member `data_bool_unbounded_dynamic`
// Member `data_int8_bounded_dynamic`
// Member `data_bool_bounded_dynamic`
#include "rosidl_runtime_c/primitives_sequence_functions.h"
// Member `data_string`
// Member `data_string_bounded`
#include "rosidl_runtime_c/string_functions.h"
// Member `data_wstring`
// Member `data_wstring_bounded`
#include "rosidl_runtime_c/u16string_functions.h"

bool
r2r_spl_test_interfaces__msg__ArrayTypes__init(r2r_spl_test_interfaces__msg__ArrayTypes * msg)
{
  if (!msg) {
    return false;
  }
  // data_int8_static
  // data_bool_static
  // data_int8_unbounded_dynamic
  if (!rosidl_runtime_c__int8__Sequence__init(&msg->data_int8_unbounded_dynamic, 0)) {
    r2r_spl_test_interfaces__msg__ArrayTypes__fini(msg);
    return false;
  }
  // data_bool_unbounded_dynamic
  if (!rosidl_runtime_c__boolean__Sequence__init(&msg->data_bool_unbounded_dynamic, 0)) {
    r2r_spl_test_interfaces__msg__ArrayTypes__fini(msg);
    return false;
  }
  // data_int8_bounded_dynamic
  if (!rosidl_runtime_c__int8__Sequence__init(&msg->data_int8_bounded_dynamic, 0)) {
    r2r_spl_test_interfaces__msg__ArrayTypes__fini(msg);
    return false;
  }
  // data_bool_bounded_dynamic
  if (!rosidl_runtime_c__boolean__Sequence__init(&msg->data_bool_bounded_dynamic, 0)) {
    r2r_spl_test_interfaces__msg__ArrayTypes__fini(msg);
    return false;
  }
  // data_string
  if (!rosidl_runtime_c__String__init(&msg->data_string)) {
    r2r_spl_test_interfaces__msg__ArrayTypes__fini(msg);
    return false;
  }
  // data_string_bounded
  if (!rosidl_runtime_c__String__init(&msg->data_string_bounded)) {
    r2r_spl_test_interfaces__msg__ArrayTypes__fini(msg);
    return false;
  }
  // data_wstring
  if (!rosidl_runtime_c__U16String__init(&msg->data_wstring)) {
    r2r_spl_test_interfaces__msg__ArrayTypes__fini(msg);
    return false;
  }
  // data_wstring_bounded
  if (!rosidl_runtime_c__U16String__init(&msg->data_wstring_bounded)) {
    r2r_spl_test_interfaces__msg__ArrayTypes__fini(msg);
    return false;
  }
  return true;
}

void
r2r_spl_test_interfaces__msg__ArrayTypes__fini(r2r_spl_test_interfaces__msg__ArrayTypes * msg)
{
  if (!msg) {
    return;
  }
  // data_int8_static
  // data_bool_static
  // data_int8_unbounded_dynamic
  rosidl_runtime_c__int8__Sequence__fini(&msg->data_int8_unbounded_dynamic);
  // data_bool_unbounded_dynamic
  rosidl_runtime_c__boolean__Sequence__fini(&msg->data_bool_unbounded_dynamic);
  // data_int8_bounded_dynamic
  rosidl_runtime_c__int8__Sequence__fini(&msg->data_int8_bounded_dynamic);
  // data_bool_bounded_dynamic
  rosidl_runtime_c__boolean__Sequence__fini(&msg->data_bool_bounded_dynamic);
  // data_string
  rosidl_runtime_c__String__fini(&msg->data_string);
  // data_string_bounded
  rosidl_runtime_c__String__fini(&msg->data_string_bounded);
  // data_wstring
  rosidl_runtime_c__U16String__fini(&msg->data_wstring);
  // data_wstring_bounded
  rosidl_runtime_c__U16String__fini(&msg->data_wstring_bounded);
}

bool
r2r_spl_test_interfaces__msg__ArrayTypes__are_equal(const r2r_spl_test_interfaces__msg__ArrayTypes * lhs, const r2r_spl_test_interfaces__msg__ArrayTypes * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // data_int8_static
  for (size_t i = 0; i < 3; ++i) {
    if (lhs->data_int8_static[i] != rhs->data_int8_static[i]) {
      return false;
    }
  }
  // data_bool_static
  for (size_t i = 0; i < 2; ++i) {
    if (lhs->data_bool_static[i] != rhs->data_bool_static[i]) {
      return false;
    }
  }
  // data_int8_unbounded_dynamic
  if (!rosidl_runtime_c__int8__Sequence__are_equal(
      &(lhs->data_int8_unbounded_dynamic), &(rhs->data_int8_unbounded_dynamic)))
  {
    return false;
  }
  // data_bool_unbounded_dynamic
  if (!rosidl_runtime_c__boolean__Sequence__are_equal(
      &(lhs->data_bool_unbounded_dynamic), &(rhs->data_bool_unbounded_dynamic)))
  {
    return false;
  }
  // data_int8_bounded_dynamic
  if (!rosidl_runtime_c__int8__Sequence__are_equal(
      &(lhs->data_int8_bounded_dynamic), &(rhs->data_int8_bounded_dynamic)))
  {
    return false;
  }
  // data_bool_bounded_dynamic
  if (!rosidl_runtime_c__boolean__Sequence__are_equal(
      &(lhs->data_bool_bounded_dynamic), &(rhs->data_bool_bounded_dynamic)))
  {
    return false;
  }
  // data_string
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->data_string), &(rhs->data_string)))
  {
    return false;
  }
  // data_string_bounded
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->data_string_bounded), &(rhs->data_string_bounded)))
  {
    return false;
  }
  // data_wstring
  if (!rosidl_runtime_c__U16String__are_equal(
      &(lhs->data_wstring), &(rhs->data_wstring)))
  {
    return false;
  }
  // data_wstring_bounded
  if (!rosidl_runtime_c__U16String__are_equal(
      &(lhs->data_wstring_bounded), &(rhs->data_wstring_bounded)))
  {
    return false;
  }
  return true;
}

bool
r2r_spl_test_interfaces__msg__ArrayTypes__copy(
  const r2r_spl_test_interfaces__msg__ArrayTypes * input,
  r2r_spl_test_interfaces__msg__ArrayTypes * output)
{
  if (!input || !output) {
    return false;
  }
  // data_int8_static
  for (size_t i = 0; i < 3; ++i) {
    output->data_int8_static[i] = input->data_int8_static[i];
  }
  // data_bool_static
  for (size_t i = 0; i < 2; ++i) {
    output->data_bool_static[i] = input->data_bool_static[i];
  }
  // data_int8_unbounded_dynamic
  if (!rosidl_runtime_c__int8__Sequence__copy(
      &(input->data_int8_unbounded_dynamic), &(output->data_int8_unbounded_dynamic)))
  {
    return false;
  }
  // data_bool_unbounded_dynamic
  if (!rosidl_runtime_c__boolean__Sequence__copy(
      &(input->data_bool_unbounded_dynamic), &(output->data_bool_unbounded_dynamic)))
  {
    return false;
  }
  // data_int8_bounded_dynamic
  if (!rosidl_runtime_c__int8__Sequence__copy(
      &(input->data_int8_bounded_dynamic), &(output->data_int8_bounded_dynamic)))
  {
    return false;
  }
  // data_bool_bounded_dynamic
  if (!rosidl_runtime_c__boolean__Sequence__copy(
      &(input->data_bool_bounded_dynamic), &(output->data_bool_bounded_dynamic)))
  {
    return false;
  }
  // data_string
  if (!rosidl_runtime_c__String__copy(
      &(input->data_string), &(output->data_string)))
  {
    return false;
  }
  // data_string_bounded
  if (!rosidl_runtime_c__String__copy(
      &(input->data_string_bounded), &(output->data_string_bounded)))
  {
    return false;
  }
  // data_wstring
  if (!rosidl_runtime_c__U16String__copy(
      &(input->data_wstring), &(output->data_wstring)))
  {
    return false;
  }
  // data_wstring_bounded
  if (!rosidl_runtime_c__U16String__copy(
      &(input->data_wstring_bounded), &(output->data_wstring_bounded)))
  {
    return false;
  }
  return true;
}

r2r_spl_test_interfaces__msg__ArrayTypes *
r2r_spl_test_interfaces__msg__ArrayTypes__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  r2r_spl_test_interfaces__msg__ArrayTypes * msg = (r2r_spl_test_interfaces__msg__ArrayTypes *)allocator.allocate(sizeof(r2r_spl_test_interfaces__msg__ArrayTypes), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(r2r_spl_test_interfaces__msg__ArrayTypes));
  bool success = r2r_spl_test_interfaces__msg__ArrayTypes__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
r2r_spl_test_interfaces__msg__ArrayTypes__destroy(r2r_spl_test_interfaces__msg__ArrayTypes * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    r2r_spl_test_interfaces__msg__ArrayTypes__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
r2r_spl_test_interfaces__msg__ArrayTypes__Sequence__init(r2r_spl_test_interfaces__msg__ArrayTypes__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  r2r_spl_test_interfaces__msg__ArrayTypes * data = NULL;

  if (size) {
    data = (r2r_spl_test_interfaces__msg__ArrayTypes *)allocator.zero_allocate(size, sizeof(r2r_spl_test_interfaces__msg__ArrayTypes), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = r2r_spl_test_interfaces__msg__ArrayTypes__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        r2r_spl_test_interfaces__msg__ArrayTypes__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
r2r_spl_test_interfaces__msg__ArrayTypes__Sequence__fini(r2r_spl_test_interfaces__msg__ArrayTypes__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      r2r_spl_test_interfaces__msg__ArrayTypes__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

r2r_spl_test_interfaces__msg__ArrayTypes__Sequence *
r2r_spl_test_interfaces__msg__ArrayTypes__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  r2r_spl_test_interfaces__msg__ArrayTypes__Sequence * array = (r2r_spl_test_interfaces__msg__ArrayTypes__Sequence *)allocator.allocate(sizeof(r2r_spl_test_interfaces__msg__ArrayTypes__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = r2r_spl_test_interfaces__msg__ArrayTypes__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
r2r_spl_test_interfaces__msg__ArrayTypes__Sequence__destroy(r2r_spl_test_interfaces__msg__ArrayTypes__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    r2r_spl_test_interfaces__msg__ArrayTypes__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
r2r_spl_test_interfaces__msg__ArrayTypes__Sequence__are_equal(const r2r_spl_test_interfaces__msg__ArrayTypes__Sequence * lhs, const r2r_spl_test_interfaces__msg__ArrayTypes__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!r2r_spl_test_interfaces__msg__ArrayTypes__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
r2r_spl_test_interfaces__msg__ArrayTypes__Sequence__copy(
  const r2r_spl_test_interfaces__msg__ArrayTypes__Sequence * input,
  r2r_spl_test_interfaces__msg__ArrayTypes__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(r2r_spl_test_interfaces__msg__ArrayTypes);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    r2r_spl_test_interfaces__msg__ArrayTypes * data =
      (r2r_spl_test_interfaces__msg__ArrayTypes *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!r2r_spl_test_interfaces__msg__ArrayTypes__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          r2r_spl_test_interfaces__msg__ArrayTypes__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!r2r_spl_test_interfaces__msg__ArrayTypes__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
